unit Debug;   // Create this form first

// 1/21/06 - Modified debug with 100 mSec timestamps
// 2/1/06 - Timestamps now 110 mSec - Modified form to display MaxRxDcount
// 2/6/06 - Removed external DLL ref
// 2/3/07 - Rewritten for OOP
// 3/18/09 - Made independent of other modules

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfmDebug = class(TForm)
    DebugTimer: TTimer;
    memoDebug: TMemo;
    btDebugHide: TButton;
    procedure ButtonHideClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DebugTimerTick(Sender: TObject);
  private
    DebugFile: TextFile;
    DebugTime: Single;
    DebugCount: Integer;
    { Private declarations }
  public
    procedure    AddDebugItem( DebugItem: String );
    procedure    SaveDebugFile;
    { Public declarations }
  end;

var
  fmDebug: TfmDebug;

implementation

{$R *.DFM}

//*************************** AddDebugItem *****************************
procedure TfmDebug.AddDebugItem( DebugItem: String );
begin
  if fmDebug <> nil then begin
    inc(DebugCount);
    fmDebug.memoDebug.Lines.Append( IntToStr(DebugCount) + ': ' +
      DebugItem + ' at: ' + FloatToStr(DebugTime/1000));
    end;
end;

//*************************** ButtonHideClick *****************************
procedure TfmDebug.ButtonHideClick(Sender: TObject);
begin
  fmDebug.Hide;
end;

//********************************* FormShow ********************************
procedure TfmDebug.FormShow(Sender: TObject);
var       s: String;
begin
  s := TComponent(Sender).name;
  AddDebugItem( 'Debug Show '+ s + ' ' );
  fmDebug.Left := 1;
end;

//******************************* SaveDebugFile ******************************
procedure   TfmDebug.SaveDebugFile;
var         i: Integer;
            S: String;
begin
    S := ExtractFileName(Application.ExeName);
    S := Copy(S,1,pos('.',S)-1) + '.dbg';
    AssignFile( DebugFile, S );
    rewrite(DebugFile);
    for i := 0 to fmDebug.memoDebug.Lines.Count-1  do  begin
      writeln(DebugFile, fmDebug.memoDebug.Lines[i] );
    end;
    closefile(DebugFile);
end;


procedure TfmDebug.DebugTimerTick(Sender: TObject);
begin
  DebugTime := DebugTime + DebugTimer.Interval;
  If DebugTime = DebugTimer.Interval then
    fmDebug.Hide;
end;

end.
