unit Delays;

// 1/29/05 - Set object nil on free
// 2/25/09 - Add DelayInProgress

interface
uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  StdCtrls,
  ExtCtrls,
  Forms,
  DelayForm;

type
  TDelayObject = class(TObject)
    Timer1: TTimer;
  private
    procedure Timer1Timer(Sender: TObject);
  public
    Timeout: Integer;
  end;

var
  DelayObject: TDelayObject;

procedure     Delay( const Msec: Integer );
procedure     DelayMsg( const Msec: Integer; const Msg: String );
procedure     DelayMsec( mSec: Integer );

implementation

procedure     Delay( const Msec: Integer );
var           fTimerEvent: TNotifyEvent;
{$J+}
const         DelayInProgress: Boolean = False;
{$J-}
begin
  If DelayInProgress = True then
    exit;
  DelayInProgress := True;
  DelayObject := TDelayObject.Create;
  DelayObject.Timeout := mSec;
  DelayObject.Timer1 := TTimer.Create(nil);
  DelayObject.Timer1.Interval := 100;
  fTimerEvent := DelayObject.Timer1Timer;
  DelayObject.Timer1.OnTimer := fTimerEvent;
  while DelayObject.Timeout > 0 do
    Application.ProcessMessages;
  DelayObject.Timer1.Free;
  DelayObject.Timer1 := nil;
  DelayObject.Free;
  DelayObject := nil;
  DelayInProgress := False;
end;

procedure     DelayMsg( const mSec: Integer; const Msg: String );
begin
  fmDelay := TfmDelay.Create(nil);
  fmDelay.Caption := Msg;
  fmDelay.Width := fmDelay.Constraints.MinWidth div 2 + 20*sizeof(Msg);
  fmDelay.Position := poScreenCenter;
  fmDelay.Show;
  DelaymSec(mSec);
  fmDelay.Free;
  fmDelay := nil;
end;

procedure TDelayObject.Timer1Timer(Sender: TObject);
begin
  if fmDelay <> nil then
    fmDelay.Edit1.Text := FloatToStr( Timeout/1000 );
  If DelayObject.TimeOut > 0 then
    DelayObject.TimeOut := DelayObject.TimeOut - 100;
end;

procedure DelayMsec( mSec: Integer );
var
   waitTill: TDateTime;
   tSec, tMsec: Integer;
 begin
//   Delay(mSec);
//   exit;
   tSec := mSec DIV 1000;
   tMsec := mSec MOD 1000;
   waitTill := Now() + EncodeTime(0, 0, tSec, tMsec);

   while (Now() <= waitTill) //time not elapsed yet
   do
   begin
     Sleep(10); //give CPU time to other threads
     if fmDelay <> nil then
       fmDelay.Edit1.Text := Format('%4.1f', [24*3600*(waitTill-Now())]);
     Application.ProcessMessages();
   end;
end;

end.
