unit xygraph; // version 1.1

{=========================================================================}
{                                                                         }
{ The Sourcefile XYGRAPH.PAS is supplied as freeware.                     }
{ As such it is subjected to copyright by international law.              }
{                                                                         }
{ XYGRAPH.PAS is intended only to make your own DCU file.                 }
{ Distribution or publication of XYGRAPH.PAS completely or partly is not  }
{ allowed, unless with specific permission of the author.                 }
{                                                                         }
{ Use of XYGRAPH.DCU in commercial software is only allowed if the        }
{ sourcefile XYGRAPH.PAS has not been changed and my name is mentioned    }
{ as the author.                                                          }
{                                                                         }
{ For all aother matters the normal copyright restictions act.            }
{                                                                         }
{ Wilko C Emmens, Castricum, The Netherlands, 2002                        }
{ mailto:wcemmens@solcon.nl                                               }
{ http://www.solcon.nl/wcemmens                                           }
{                                                                         }
{ Please contact the author for proposed modifications or improvements    }
{ or any other matter.                                                    }
{                                                                         }
{=========================================================================}

interface

{$D '>>>  XYGRAPH 1.1  (C) WILKO C EMMENS 2002   <<<'}

uses Windows , {Messages,} SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    {StdCtrls, Spin,} ExtCtrls, Clipbrd{, AppEvnts};

type float = single;

const maxgraf = 8;

const lin = false; log = true;
      fixed = true; sci = false;
      gridon = true; gridoff = false;
      clipon = false; clipoff = true;
      msgon = true; msgoff = false;
      frameon = true; frameoff = false;
var   xypixx,xypixy : float;               {afmeting van 1 pixel}
      xycharwidth, xycharheight : integer; {karakter afmetingen}
      xyzoomx, xyzoomy : float;            {zoomfactoren}
      xylegendcount : integer;             {aantal entries}


type axistype = record                        {waardes en instellingen van assen}
                on : boolean;
                min,max : float;
                log : boolean;
                end;
type  graphtype = record                       {instelingen hele grafiek}
                 ok : boolean;                 {ok}
                 x1,y1,x2,y2 : integer;        {plotveld in abs waarden}
                 xaxis : axistype;             {asinstellingen}
                 yaxis : array[1..4] of axistype;
                end;
var xygraphdata : array[1..maxgraf] of graphtype;

procedure xylanguage(n:integer);
procedure xyabstouser(xp,yp:integer; var x,y:float);
procedure xyusertoabs(x,y:float; var xp,yp:integer);

procedure xyunzoomx(n:integer);
procedure xyunzoomy(n:integer);
procedure xyunzoom(n:integer);
procedure xysetzoom(n:integer; fx0,fx1,fy0,fy1:float);

procedure xycleargraph(paintbox:Tpaintbox; bcolor,fcolor:Tcolor; scale:float);
procedure xystartgraph(x1,x2,y1,y2,dx1,dx2,dy1,dy2:integer; nclip:boolean);
procedure xysetgridlines(xcoarse,xfine,ycoarse,yfine:integer);
procedure xytitle(cl:Tcolor;txt:string);
procedure xyxaxis(cl:Tcolor;x1,x2,incr,zmx:float;txt:string;grid,log,fix:boolean);
procedure xyyaxis(cl:Tcolor;y1,y2,incr,zmx:float;txt:string;code:integer;grid,log,fix:boolean);
procedure xyyearaxis(cl:Tcolor;code,jaar:integer;grid:boolean);
procedure xylabelaxis(cl:Tcolor;labels:array of string;grid:boolean);
procedure xymove(x,y:float);
procedure xydraw(x,y:float);
procedure xysymbol(st,sz,fl:integer);
procedure xysymbolp(st,sz,fl:integer;x,y:float);
procedure xytext(cl:Tcolor;txt:string;x,y:float;xjust,yjust,mode:integer);
procedure xyfinish;
procedure xybar(cl:Tcolor;pos,wi,hi:float;just:integer);
procedure xylegendentry(cd:integer; text:string);
procedure xylegendclear;
procedure xylegendmake(style,xp,yp,xjust,yjust,wi,he,len:integer; framed:boolean);
procedure xyinitruler(cl:Tcolor;xp,yp,j:integer);
procedure xysetusercoordinates(n,ny:integer);

procedure xycopytoclipboard;
procedure xysaveasmetafile(s:string; showtxt:boolean; var ok:boolean);
procedure XYMouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
procedure XYMouseMove(Shift: TShiftState;  X, Y: Integer);
procedure XYMouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
procedure XYKeyDown(Key: Word; Shift: TShiftState);

implementation

uses math;

type astype = record                           {waardes en instellingen van assen}
                on,log : boolean;
                col:Tcolor;
                mi,ma,dlog,pix : float;
                org,len,ndec,ninc,typ : integer;
               end;
     graftype = record                         {instelingen hele grafiek}
                 x1,x2,y1,y2 : integer;        {veld in %}
                 xf0,xf1,yf0,yf1 : float;      {zoomfactoren}
                 xgridc,xgridf,ygridc,ygridf : integer; {rasterlijnen}
                 ok,nclip : boolean;           {ok,noclip}
                 zmxx, zmxy : float;           {zoomgrenzen}
                 as_ : array[0..4] of astype;  {asinstellingen}
                end;

var xorg,yorg,xlen,ylen : integer;    {offset en lengte asssen}
    xmi,xma,ymi,yma : float;          {min en amx waarde assen}
    xlog,ylog : boolean;              {assen logarithmisch}
    dxlog,dylog : float;              {omrekenfactoren bij log as}
    tsize,hsize : integer;            {ticsize}
    fsize : float;                    {relatieve fontgrootte}
    ndecx,ndecy,nincx,nincy : integer;{aantal decimalen}
    width,height : integer;           {afmetingen canvas}
    grafok, grafokx, grafoky : boolean;  {id}
    xincr, yincr : float;             {kleinste increment}
    zmaxx, zmaxy : float;             {max. zoomfactor (inverse)}
    xfix,yfix : boolean;              {alleen vaste komma notatie}
    noclip : boolean;                 {controleer niet op clippen}
    lposx,lposy : integer;            {laatste x,y plot positie}
    useroff : boolean;                {user coord uitgeschakeld}
    bar0 : integer;                   {nullijn voor bar bij user off}

    blokx0,blokx1,bloky0,bloky1 : integer; {positie blok}
    blokon : boolean;                 {blok aan}

    crossx, crossy : integer;         {waarden lineaal}
    crossxp, crossyp, crossj : integer; {positie lineaal gegevens}
    crosson, crossok : boolean;       {lineaal aan, geef waarden}
    crosscolor : Tcolor;              {lineaal kleur}
    crossas : integer;                {bij welke y-as hoort lineaal}

    graphs : array[1..maxgraf] of graftype; {instelingen van alle grafieken}
    igraph, ngraph : integer;         {actuele grafiek, aantal grafieken}
    izoom, zgraph : integer;          {laatst gezoomde grafiek; 1 grafiek}
    lastsymb : record col,wi,xx,yy,s1,s2,s3 : integer; end; {laatste symbool}

    dag : array[1..13] of integer;    {begindagen in het jaar van een maand}

    oldpen : Tpen;                    {vorige pen}
    oldbrush : Tbrush;                {vorige brush}

    taal,q : integer;

const maanddagen : array[1..12] of integer =
        (31,28,31,30,31,30,31,31,30,31,30,31);
      zmax = 1/1000;
      lmax = 2.00;
      logtics : array[0..4] of set of byte =
         ( [10],
           [10,20,50],
           [10,20,30,40,50,60,70,80,90],
           [10,12,14,16,18,20,25,30,35,40,45,50,60,70,80,90],
           [10,11,12,13,14,15,16,17,18,19,20,22,24,26,28,30,32,34,36,38,40
             ,42,44,46,48,50,55,60,65,70,75,80,85,90,95] );

type symboltype = record
                   xp,yp:word;
                   style,size,fill,width : byte;
                   color:Tcolor;
                 end;
var  symbols : array of symboltype;   {lijst van symbolen die nog moeten}
     nsymbols : integer;              {aantal symbolen in de lijst}
     lastsymbol : symboltype;         {laatst gemelde xysymbol}

     lastpoint : boolean;             {moet er nog een laatse punt}
     islastpoint : record x,y:integer;col:Tcolor end; {wat is dit punt}

type legendtype = record
                   txt : string;
                   cl : Tcolor;
                   code : integer; {0=line, 1=bar, 2=symbol}
                   lwidth, lstyle, lfill : integer;
                   end;

var legends : array of legendtype;    {lijst van legend entries}

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXX EX COMMON XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

function red(cl:Tcolor):integer;
begin red := colortorgb(cl) shr 0 and $FF; end;

function green(cl:Tcolor):integer;
begin green := colortorgb(cl) shr 8 and $FF; end;

function blue(cl:Tcolor):integer;
begin blue := colortorgb(cl) shr 16 and $FF; end;

function mixcolor(cl1,cl2:Tcolor;f1,f2 : integer):Tcolor;
begin
  if (f1<=0) or (f2<=0) then begin mixcolor := clblack; exit; end;
  mixcolor :=
   ( ( red(cl1) * f1 + red(cl2) * f2 ) div (f1+f2) ) and $FF shl 0 +
   ( ( green(cl1) * f1 + green(cl2) * f2 ) div (f1+f2) ) and $FF shl 8 +
   ( ( blue(cl1) * f1 + blue(cl2) * f2 ) div (f1+f2) ) and $FF shl 16;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXX EX WMF XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

var fn : file;
    buf : array[1..64] of word;
    bufd : cardinal absolute buf;
    flsize, maxlen, nobj : integer;
    fnaam : string;

    ok : boolean;

procedure dosize(n:integer);
begin
  inc(flsize,n);
  if (n>maxlen) then maxlen := n;
end;

procedure dorecord;
begin
  blockwrite(fn,buf,bufd);
  dosize(bufd);
end;

procedure fillintext(s:string; pos:integer; nul:boolean);
var i : integer;
begin
  if (s='') then s := ' ';
  if nul then s := s + #0;
  if odd(length(s)) then s := s + #32;
  for i := 1 to length(s) div 2 do
    begin
      buf[pos] := ord(s[i*2-1]) + ord(s[i*2]) shl 8;
      bufd := pos;
      inc(pos);
    end;
end;

procedure fillincolor(color:Tcolor; pos:integer);
begin
  buf[pos] := red(color) + green(color) shl 8;
  buf[pos+1] := blue(color) + 2 shl 8;
  buf[pos+2] := 0;
end;

procedure startwmf(var s:string;var ok : boolean);
var i : integer;
begin
  s := changefileext(s,'.wmf');
  fnaam := s;
  assignfile(fn,s); rewrite(fn,2);
  ok := (ioresult=0);  
  if ok then
   begin
     for i := 1  to 20 do buf[i] := 0;
     blockwrite(fn,buf,11+9);
     flsize := 20; maxlen := 0; nobj := 3;
    end;
end;

procedure finishwmf(x,y,inch:integer;var ok:boolean);
var csum,i  : integer;
begin
  bufd := 3; buf[3] := 0; dorecord;  {EOF}

  bufd := $9AC6CDD7;    {Aldus header}
  buf[3] := 0;
  buf[4] := 0; buf[5] := 0;
  buf[6] := x; buf[7] := y;
  buf[8] := inch;
  buf[9] := 0; buf[10] := 0;
  csum := 0; for i := 1 to 10 do csum := csum xor buf[i];
  buf[11] := csum;
  seek(fn,0); blockwrite(fn,buf,11);

  buf[1] := 1;             {standard header}
  buf[2] := 9;
  buf[3] := $300;
  buf[4] := flsize and 65535;  buf[5] := flsize shr 16;
  buf[6] := nobj;
  buf[7] := maxlen and 65535; buf[8] := maxlen shr 16;
  buf[9] := 0;
  blockwrite(fn,buf,9);
  closefile(fn);

  ok := fileexists(fnaam);
  if ok then
    begin
      assignfile(fn,fnaam); reset(fn,1);
      ok := (filesize(fn)=flsize*2); closefile(fn);
    end;
end;

procedure setsize(x,y:integer);
begin
  bufd := 4; buf[3] := $0103; buf[4] := 8; dorecord; {Mapmode};
  bufd := 5; buf[3] := $020B; buf[4] := 0; buf[5] := 0; dorecord; {Windoworg}
  bufd := 5; buf[3] := $020C; buf[4] := y; buf[5] := x; dorecord; {Windowext}
end;

procedure setbrush(style:integer;color:Tcolor);
begin
  bufd := 7; buf[3] := $02FC; buf[4] := style;
  fillincolor(color,5); dorecord; {createbrushindirect}
end;

procedure textcolor(color:Tcolor);
begin
  bufd := 5; buf[3] := $0209;
  fillincolor(color,4); dorecord; {settextcolor}
end;

procedure setfont(he,wi:integer;font:Tfont);
var s : string;
begin
  bufd := 0; buf[3] := $02FB;
  buf[4] := word(he); buf[5] := wi;
  buf[6] := 0; buf[7] := 0;
  if fsbold in font.style then buf[8] := 700 else buf[8] := 400;
  buf[9] := 0; if fsitalic in font.style then buf[9] := 1;
  if fsunderline in font.style then buf[9] := buf[9] + 256;
  buf[10] := 0; if fsstrikeout in font.style then buf[10] := 1;
  buf[10] := buf[10] + 1*256;
  buf[11] := 0 + 0*256;
  buf[12] := 0 + 0*256;
  s := font.name; fillintext(s,13,true);
  dorecord; {createfontindirect}

  textcolor(font.color);
end;

procedure extrachar(n:integer);
begin
  bufd := 4; buf[3] := $0108; buf[4] := n; dorecord; {settextcharextra}
end;

procedure textwmfalign(n:integer);
begin
  bufd := 4; buf[3] := $012E; buf[4] := n; dorecord; {settextalign}
  (*   0   6   2
      24  30  26
       8  14  10 *)
end;

procedure textwmfout(x,y:integer;txt:string);
begin
  bufd := 0; buf[3] := $0521; buf[4] := length(txt);
  fillintext(txt,5,false); inc(bufd,2);
  buf[buf[1]-1] := y; buf[bufd] := x; dorecord; {textout}
end;

procedure setpen(style,wi:integer; color:Tcolor);
begin
  bufd := 9; buf[3] := $02FA; buf[4] := style; buf[5] := wi; buf[6] := 0;
  fillincolor(color,7); dorecord; {createpenindirect}
end;

procedure selectobject(n:integer);
begin
  bufd := 4; buf[3] := $012D; buf[4] := n; dorecord; {selectobject}
end;

procedure deleteobject(n:integer);
begin
  bufd := 4; buf[3] := $01F0; buf[4] := n; dorecord; {deleteobject}
end;

procedure blokwmf(x1,y1,x2,y2:integer);
begin
  bufd := 7; buf[3] := $041B;
  buf[4] := y2; buf[5] := x2; buf[6] := y1; buf[7] := x1;
  dorecord; {rectangle};
end;

procedure ellipsewmf(x1,y1,x2,y2:integer);
begin
  bufd := 7; buf[3] := $0418;
  buf[4] := y2; buf[5] := x2; buf[6] := y1; buf[7] := x1;
  dorecord; {ellipse};
end;

procedure bkmode(n:integer);
begin
  bufd := 4; buf[3] := $0102; buf[4] := n; dorecord; {setbkmode}
end;

procedure comment(txt:string);
begin
  bufd := 0; buf[3] := $0626; buf[4] := 15;
  buf[5] := length(txt); fillintext(txt,6,false);
  dorecord; {escape};
end;

procedure movewmf(x,y:integer);
begin
  bufd := 5; buf[3] := $0214; buf[4] := y; buf[5] := x;
  dorecord; {moveto};
end;

procedure drawwmf(x,y:integer);
begin
  bufd := 5; buf[3] := $0213; buf[4] := y; buf[5] := x;
  dorecord; {lineto};
end;

procedure pixelwmf(x,y:integer;color:Tcolor);
begin
  bufd := 7; buf[3] := $041F; fillincolor(color,4);
  buf[6] := y; buf[7] := x; dorecord; {setpixel};
end;

procedure polygonwmf(points: array of Tpoint);
var i,n : integer;
begin
  n := length(points);
  bufd := n*2+4; buf[3] := $0324; buf[4] := n;
  for i := 1 to n do
    begin
      buf[i*2+3] := points[i-1].x;
      buf[i*2+4] := points[i-1].y;
    end;
  dorecord; {polygon}
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXX EX XYWMF XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

var xycanvas : Tcanvas;
    xypaintbox : Tpaintbox;
    frontcolor,backcolor : Tcolor;    {default kleuren}
    dowmf : boolean;

var penwidth : integer;
    penstyle : integer;
    pencolor : Tcolor;
    fontcolor : Tcolor;
    fontsize : integer;
    fontstyle: Tfontstyles;
    brushcolor : Tcolor;
    brushstyle : integer;

    cgrid,fgrid : array of word;
    ncgrid,nfgrid : integer;

procedure initgrid;
begin
  setlength(cgrid,0); setlength(fgrid,0);
  ncgrid := 0; nfgrid := 0;
end;

procedure addcoarse(p:integer);
begin
  inc(ncgrid); setlength(cgrid,ncgrid);
  cgrid[ncgrid-1] := p;
end;

procedure addfine(p:integer);
begin
  inc(nfgrid); setlength(fgrid,nfgrid);
  fgrid[nfgrid-1] := p;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

procedure checkwmfpen;
begin
  with xycanvas.pen do
    if (color<>pencolor) or (integer(style)<>penstyle) or (width<>penwidth) then
      begin
        deleteobject(1);
        setpen(integer(style),width,color);
        selectobject(1);
        pencolor := color;
        penstyle := integer(style);
        penwidth := width;
      end;
end;

procedure fontwmf;
var h,w,e : integer;
begin
  with xycanvas.font do
    begin
      h := height;
      if name = 'Small Fonts' then
         begin w := 0; e := size div 3; if fsbold in style then inc(e); end
      else
      if name = 'Arial' then
        begin w := round(xycharwidth*0.85); e := 0; end
      else
      {if name = 'MS Sans Serif' then}
        begin w := 0; e := size div 3; if fsbold in style then inc(e); end;
    end;
  setfont(h,w,xycanvas.font);
  extrachar(e);
end;

procedure checkwmffont;
begin
  with xycanvas.font do
    if (style<>fontstyle) or (size<>fontsize) then
      begin
        deleteobject(2);
        fontwmf;
        selectobject(2);
        fontcolor := color;
        fontstyle := style;
        fontsize := size;
      end
    else if (color<>fontcolor) then
      begin
        textcolor(color);
        fontcolor := color;
      end;
end;

procedure checkwmfbrush;
begin
  with xycanvas.brush do
    if (color<>brushcolor) or (integer(style)<>brushstyle) then
      begin
        deleteobject(0);
        setbrush(integer(style),color);
        selectobject(0);
        brushcolor := color;
        brushstyle := integer(style);
      end;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

procedure openwmf(var s:string;var ok:boolean);
begin
  if (s='') then s := 'xygraph.wmf';
  startwmf(s,ok);
  dowmf := ok;
end;

procedure initwmf;
var x,y : integer;
begin
  x := xypaintbox.width; y := xypaintbox.height;
  comment('File created by XYGRAPH');
  comment('(C) Wilko C Emmens 2002');
  setsize(x,y);
  setbrush(0,backcolor);
    brushcolor := backcolor; brushstyle := 0;
  selectobject(0);
  setpen(0,1,frontcolor);
    pencolor := frontcolor; penstyle := 0; penwidth := 1;
  selectobject(1);
  fontwmf;
    fontsize := xycanvas.font.size;
    fontcolor := xycanvas.font.color;
    fontstyle := xycanvas.font.style;
  selectobject(2);
  blokwmf(0,0,x,y);
  bkmode(1);
end;

procedure linewmf(x1,y1,x2,y2:integer);
begin movewmf(x1,y1); drawwmf(x2,y2); end;

procedure closewmf(var ok:boolean);
var x,y : integer;
begin
  x := xypaintbox.width; y := xypaintbox.height;
  finishwmf(x,y,screen.pixelsperinch,ok);
  dowmf := false;
end;

procedure dogrid(p1,p2:integer;xas:boolean);
var i : integer;
    col : Tcolor;
begin
  xycanvas.pen.style := psdot; col := xycanvas.pen.color;
  if (nfgrid>0) then
    begin
      xycanvas.pen.color := mixcolor(col,backcolor,1,3);
      checkwmfpen;
      for i := 0 to nfgrid-1 do
        if xas then linewmf(fgrid[i],p1,fgrid[i],p2)
               else linewmf(p1,fgrid[i],p2,fgrid[i]);
    end;
  if (ncgrid>0) then
    begin
      xycanvas.pen.color := col;
      checkwmfpen;
      for i := 0 to ncgrid-1 do
        if xas then linewmf(cgrid[i],p1,cgrid[i],p2)
               else linewmf(p1,cgrid[i],p2,cgrid[i]);
    end;
  xycanvas.pen.style := pssolid;
  xycanvas.pen.color := col;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXX EX XYGRAF XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

procedure xylanguage(n:integer); begin taal := n; end; {XXXXXXXXXXXXXXXXXXXXXXX}

procedure store; begin oldpen.assign(xycanvas.pen); oldbrush := xycanvas.brush; end;
procedure restore; begin xycanvas.pen.assign(oldpen); xycanvas.brush := oldbrush; end;

function posx(x:float):integer; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {berekent de x positie op het scherm}
var pos : double;
begin
   if xlog then if (x<=0) then x := xmi/2;
   if xlog then pos := xorg + ln(x/xmi)/dxlog*xlen
           else pos := xorg + (x-xmi)/(xma-xmi)*xlen;
   if (pos<-32768) then pos := -32768 else if (pos>32767) then pos := 32767;
   posx := round(pos);
end;

function posy(y:float):integer; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {berekent de y positie op het scherm}
var pos : double;
begin
   if ylog then if (y<=0) then y := ymi/2;
   if ylog then pos := yorg - ln(y/ymi)/dylog*ylen
           else pos := yorg - (y-ymi)/(yma-ymi)*ylen;
   if (pos<-32768) then pos := -32768 else if (pos>32767) then pos := 32767;
   posy := round(pos);
end;

function xwaarde(x:integer):float; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {berekent x waarde bij een bepaalde positie scherm}
begin
   if (x<0) then x := 0 else if (x>width) then x := width;
   with graphs[igraph].as_[0] do
   if log then xwaarde := mi * exp((x-org)/len*dlog)
          else xwaarde := mi + (x-org)/len*(ma-mi);
end;

function ywaarde(y,n:integer):float; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {berekent y waarde bij een bepaalde positie scherm voor xyyaxis n}
begin
   if (y<0) then y := 0 else if (y>height) then y := height;
   if (n=0) then {actuele yas}
     begin
       if ylog then ywaarde := ymi * exp((yorg-y)/ylen*dylog)
               else ywaarde := ymi + (yorg-y)/ylen*(yma-ymi);
     end
   else
     with graphs[igraph].as_[n] do
       if log then ywaarde := mi * exp((org-y)/len*dlog)
              else ywaarde := mi + (org-y)/len*(ma-mi);
end;

procedure xyabstouser(xp,yp:integer; var x,y:float); {XXXXXXXXXXXXXXXXXXXXXXXXX}
begin x := xwaarde(xp); y := ywaarde(yp,0); end;

procedure xyusertoabs(x,y:float; var xp,yp:integer); {XXXXXXXXXXXXXXXXXXXXXXXXX}
begin xp := posx(x); yp := posy(y); end;

function plus(x:integer):integer; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin plus := max(x,0); end;

function datum(n:integer):string; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {geeft de datumweergave van dag n}
var m,d:integer;
begin
  if (n<1) or (n>dag[13]) then begin datum := ' - '; exit; end;
  m := 0; repeat inc(m) until (dag[m+1]>=n);
  d := n-dag[m]; datum := inttostr(d)+'-'+inttostr(m);
end;

{------------------------------------------------------------------------------}

function showdec(w:float; ndec:integer):string; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {geeft tekst normaal met n decimalen}
var f : float; s : string;
begin
 if (ndec<0) then
   begin
     f := power(10,-ndec); w := round(w/f) * f; ndec := 0;
   end;
 str(w:1:ndec,s); showdec := s;
end;

function lintext(w:float;ndec:integer):string; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
  {tekst bij lin. as eenheden in sci notatie}
var i,t,n : integer;
    s : string;
begin
  if (w=0) then s := '0' else
  if (ndec<=-3) then
    begin
      for i := 1 to -ndec do w := w / 10;
      str(w:1:0,s); s := s + 'E' + chr(48-ndec);
    end else
  if (ndec<=0) then str(w:1:0,s) else
  if (abs(w)>=0.01) then str(w:1:ndec,s) else
    begin
      t := 0; repeat w:=w*10; inc(t) until (abs(w)>1);
      n := ndec-t; if (n<0) then n := 0;
      str(w:1:n,s); s := s + 'E-' +chr(48+t);
    end;
 lintext := s;
end;

function logtxt(i,n:integer):string; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {tekst bij log. as eenheden}
var s,ss : string;
    p : integer;
begin
   case i of
     -2 : s := '0.01';
     -1 : s := '0.1';
      0 : s := '1';
      1 : s := '10';
      2 : s := '100';
      3 : s := '1000';
    else begin str(i:1,ss); s := '1E'+ss; end;
    end;
   ss := chr(48+n); p := pos('1',s); s[p] := ss[1];
   logtxt := s;
end;

function ndecim(f:float):integer; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
  {bepaalt hoeveel deciamlen nodig zijn voor getal f}
begin
  f := abs(f);
  if (f=0) then ndecim := 99 else
  if (f>1) then ndecim := -trunc(log10(f*1.001)) else
  if (f<1) then ndecim := -trunc(log10(f*1.001))+1;
end;

function signif(t:float;n : integer):string; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
  {geeft getal met n sign cijfers in sci notatie}
var s,ss : string;
    l,i : integer;
begin
   l := trunc(log10(t))+1; if (t<1) then dec(l);
   if (l<=n+1) and (l>-2) then
     begin
       str(t:0:plus(n-l),s);
       if (l>n) then for i := n+1 to length(s) do s[i]:= '0';
     end
   else
     begin
      str(t:20:-1,ss);
      s := copy(ss,2,n+1) + 'E';
      if (ss[16]='-') then s := s + '-';
      if (ss[19]<>'0') then s := s + ss[19];
      s := s + ss[20];
    end;
   signif := s;
end;

{------------------------------------------------------------------------------}

procedure xgrid(xp:integer; fine:boolean); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {tekent gridline voor x-as}
var y,mode : integer;
begin
  if (xp=xorg) then exit;
  if fine then mode := graphs[igraph].xgridf
          else mode := graphs[igraph].xgridc;
  if (mode<0) then exit;

  if (mode=0) then
    begin
      xycanvas.pen.style := pssolid;
      xycanvas.moveto(xp,yorg);
      xycanvas.LineTo(xp,yorg-ylen);
      if dowmf then
        begin checkwmfpen; linewmf(xp,yorg,xp,yorg-ylen);end;
    end
  else
    begin
      for y := yorg-ylen to yorg do
        if y and mode = 0 then xycanvas.pixels[xp,y]:=xycanvas.pen.color;
      if dowmf then if fine then addfine(xp) else addcoarse(xp);
    end;
end;

procedure ygrid(yp:integer; fine:boolean); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {tekent gridline voor x-as}
var x,mode : integer;
begin
  if (yp=yorg) or (mode<0) then exit;
  if fine then mode := graphs[igraph].ygridf
          else mode := graphs[igraph].ygridc;
  if (mode<0) then exit;

  if (mode=0) then
    begin
      xycanvas.pen.style := pssolid;
      xycanvas.moveto(xorg,yp);
      xycanvas.LineTo(xorg+xlen,yp);
      if dowmf then
        begin checkwmfpen; linewmf(xorg,yp,xorg+xlen,yp); end;
    end
  else
    begin
      for x := xorg to xorg+xlen do
        if x and mode = 0 then xycanvas.pixels[x,yp]:=xycanvas.pen.color;
      if dowmf then if fine then addfine(yp) else addcoarse(yp);
    end;
end;

procedure drawlastpoint; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
  with islastpoint do
    begin
      xycanvas.pixels[x,y] := col;
      if dowmf then pixelwmf(x,y,col);
    end;
  lastpoint := false;
end;

procedure setlastpoint(x,y:integer;col:Tcolor); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
  lastpoint := true;
  islastpoint.x := x;
  islastpoint.y := y;
  islastpoint.col := col;
end;

procedure cliplineto(x2,y2:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
  {teken lijn met inachtname van clipping}
var x1,y1,xx,yy,t: integer;
procedure drawline;
begin
  if dowmf then with xycanvas.penpos do
    begin
      if (x=x1) and (y=y1) then drawwmf(x2,y2) else
      linewmf(x1,y1,x2,y2);
    end;
  xycanvas.moveto(x1,y1); xycanvas.lineto(x2,y2);
  with xycanvas.pen do if (width=1) then
    if (x2<xorg+xlen) and (y2<yorg) and (y2>yorg-ylen) then
      setlastpoint(x2,y2,color);
end;
begin
  x1 := lposx; y1 := lposy; lposx := x2; lposy := y2;
  xx := xorg + xlen; yy := yorg - ylen;
  if (x1>x2) then {sorteer x1 en x2}
    begin t := x1; x1 := x2; x2 := t; t := y1; y1 := y2; y2 := t; end;

  if (x1>xorg) and (x2<xx) and
    (y1>=yy) and (y1<=yorg) and (y2>=yy) and (y2<=yorg) then
  begin drawline; exit; end; {lijn valt geheel binnen kader}

  if (x2<xorg) or (x1>xx) or ( (y1<yy) and (y2<yy) ) or ( (y1>yorg) and (y2>yorg) )
   then exit; {lijn valt geheel buiten kader}

  if (x1=x2) then {verticale lijn, test clipping y waarden}
    begin
      if (y1=y2) then exit;
      if (y1<yy) then y1 := yy else if (y1>yorg) then y1 := yorg;
      if (y2<yy) then y2 := yy-1 else if (y2>yorg) then y2 := yorg+1;
      drawline; exit;
    end;

  {test nu clipping van x waarden}
  if (x1<xorg) then begin y1 := y1 + round((xorg-x1)/(x2-x1)*(y2-y1)); x1 := xorg; end;
  if (x2>xx)   then begin y2 := y2 + round((xx+1-x2)/(x2-x1)*(y2-y1)); x2 := xx+1; end;
  if ( (y1<yy) and (y2<yy) ) or ( (y1>yorg) and (y2>yorg) ) then exit;
   {lijn valt nu alsnog geheel buiten kader}

  if (y1>=yy) and (y1<=yorg) and (y2>=yy) and (y2<=yorg) then
     begin drawline; exit; end; {lijn valt nu alsnog geheel binnen kader}

  {test nu clipping van y waarden}
  if (y2>y1) then
    begin
      if (y1<yy)   then begin x1 := x1 + round((yy-y1)/(y2-y1)*(x2-x1)); y1 := yy; end;
      if (y2>yorg) then begin x2 := x2 + round((yorg+1-y2)/(y2-y1)*(x2-x1)); y2 := yorg+1; end;
      drawline;
    end
  else
    begin
      if (y2<yy)   then begin x2 := x2 + round((yy-1-y2)/(y2-y1)*(x2-x1)); y2 := yy-1; end;
      if (y1>yorg) then begin x1 := x1 + round((yorg-y1)/(y2-y1)*(x2-x1)); y1 := yorg; end;
      drawline;
    end;
end;

procedure xymove(x,y:float); {XXXXXXXXXXXXXXXXXCCXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {verplaatst penpositie}
var xp,yp : integer;
begin
  if lastpoint then drawlastpoint;
  if not grafoky then exit;

  if useroff then
    begin xp := round(x); yp := round(y); end
  else
    begin xp := posx(x); yp := posy(y); end;

  if noclip or useroff then
    begin xycanvas.moveto(xp,yp);
     if dowmf then movewmf(xp,yp); end
  else begin lposx := xp; lposy := yp; end;
end;

procedure xydraw(x,y:float); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {tekent lijn}
var xp,yp : integer;
begin
  if not grafoky then exit;

  if useroff then
    begin xp := round(x); yp := round(y); end
  else
    begin xp := posx(x); yp := posy(y); end;

  if dowmf then checkwmfpen;
  if noclip or useroff then with xycanvas.pen do
    begin
       xycanvas.lineto(xp,yp);
       if dowmf then drawwmf(xp,yp);
       if (width=1) then setlastpoint(xp,yp,color);
     end
  else cliplineto(xp,yp);
end;

{------------------------------------------------------------------------------}

procedure drawsymbol(symb:symboltype); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {tekent symbool}
var d,d2 : integer;
    points : array[0..2] of Tpoint;
begin
  with xycanvas do with symb do begin

  d := size div 2; d2 := d + d div 2;

  if (style=0) or (d<=0) then
    begin
      pixels[xp,yp] := pen.color;
      if dowmf then pixelwmf(xp,yp,pen.color);
      exit;
    end;

  pen.width := width; pen.style := pssolid; pen.color := color;
  case fill of
    0 : brush.style := bsclear;
    1 : begin brush.style := bssolid; brush.color := backcolor; end;
    2 : begin brush.style := bssolid; brush.color := color; end;
  end;
  if dowmf then begin checkwmfpen; checkwmfbrush; end;
  case style of
   1 : begin ellipse(xp-d,yp-d,xp+d+1,yp+d+1);
          if dowmf then ellipsewmf(xp-d,yp-d,xp+d+1,yp+d+1); end;
   2 : begin rectangle(xp-d,yp-d,xp+d+1,yp+d+1);
          if dowmf then blokwmf(xp-d,yp-d,xp+d,yp+d); end;
   3 : begin points[0] := point(xp-d,yp+d); points[1] := point(xp+d,yp+d);
             points[2] := point(xp,yp-d2); polygon(points);
             if dowmf then polygonwmf(points); end;
   4 : begin points[0] := point(xp-d,yp-d); points[1] := point(xp+d,yp-d);
             points[2] := point(xp,yp+d2); polygon(points);
             if dowmf then polygonwmf(points); end;
   5 : begin points[0] := point(xp-d,yp+d); points[1] := point(xp-d,yp-d);
             points[2] := point(xp+d2,yp); polygon(points);
             if dowmf then polygonwmf(points); end;
   6 : begin points[0] := point(xp+d,yp+d); points[1] := point(xp+d,yp-d);
             points[2] := point(xp-d2,yp); polygon(points);
             if dowmf then polygonwmf(points); end;
   7 : begin moveto(xp,yp-d); lineto(xp,yp+d+1);
             moveto(xp+d,yp); lineto(xp-d-1,yp);
             if dowmf then
               begin
                 linewmf(xp,yp-d,xp,yp+d+1);
                 linewmf(xp+d,yp,xp-d-1,yp);
               end;
             end;
   8 : begin moveto(xp-d+1,yp-d+1); lineto(xp+d,yp+d);
             moveto(xp+d-1,yp-d+1); lineto(xp-d,yp+d);
             if dowmf then
               begin
                 linewmf(xp-d+1,yp-d+1,xp+d,yp+d);
                 linewmf(xp+d-1,yp-d+1,xp-d,yp+d);
               end;
             end;
   end;
   end;
end;

procedure drawallsymbols;
 {tekent alle symbolden}
var i : integer;
begin
  if (nsymbols=0) then exit;
  store;
  for i := 1 to nsymbols do drawsymbol(symbols[i-1]);
  nsymbols := 0; restore;
end;

procedure addsymbol(x,y,st,sz,fl,wi:integer;col:Tcolor); {XXXXXXXXXXXXXXXXXXXXX}
 {voegt symbool toe aan lijst}
begin
  if ( not (st in [0..8]) ) or ( not fl in [0..2] ) then exit;

  if (sz=0) then sz := xycanvas.font.size else
  if (sz<0) then begin x := 0; y := 0; end;

  with lastsymbol do
    begin xp := x; yp := y; style := st; size := sz; fill := fl;
          width := wi; color := col; end;

  if (sz<0) then exit;

  if (x<0) or (x>=width) or (y<0) or (y>=height) then exit;
  if not (useroff or noclip) then
    if (x<xorg) or (x>xorg+xlen) or (y<yorg-ylen) or (y>yorg) then exit;

  inc(nsymbols); setlength(symbols,nsymbols);
  symbols[nsymbols-1] := lastsymbol;
end;

procedure xysymbolp(st,sz,fl:integer;x,y:float); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {verwerkt symbool met x,y}
var xp,yp : integer;
begin
  if useroff then
    begin xp := round(x); yp := round(y); end
  else
    begin xp := posx(x); yp := posy(y); end;
  with xycanvas do addsymbol(xp,yp,st,sz,fl,pen.width,pen.color);
end;

procedure xysymbol(st,sz,fl:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {verwerkt symbool zonder x,y}
var xp,yp : integer;
begin
  if noclip or useroff then
    begin xp := xycanvas.penpos.x; yp := xycanvas.penpos.y; end
  else
    begin xp := lposx; yp := lposy; end;
  with xycanvas do addsymbol(xp,yp,st,sz,fl,pen.width,pen.color);
end;

{------------------------------------------------------------------------------}

procedure xytext(cl:Tcolor;txt:string;x,y:float;xjust,yjust,mode:integer);
 { mode 0=trans,noframe; 1=transp,frame; 2=obl,noframe; 3 = obl,frame }
var lines : array of string;
    nlines,p,wi,he,w,i,xp,xpw,yp : integer;
const del = '|';
      d = 3;
begin
  if useroff then
    begin xp := round(x); yp := round(y); end
  else
    begin xp := posx(x); yp := posy(y); end;

  if (xp<0) or (xp>=width) or (yp<0) or (yp>=height) then exit;
  if not (useroff or noclip) then
    if (xp<xorg) or (xp>xorg+xlen) or (yp<yorg-ylen) or (yp>yorg) then exit;

  setlength(lines,1); p := pos(del,txt); nlines := 0;
  if (p=0) then
     begin lines[0] := txt; nlines := 1; end
  else
    begin
      repeat
        inc(nlines); setlength(lines,nlines);
        lines[nlines-1] := copy(txt,1,p-1);
        txt := copy(txt,p+1,length(txt));
        p := pos(del,txt);
      until (p=0);
      inc(nlines); setlength(lines,nlines);
      lines[nlines-1] := txt;
    end;
  he := nlines * xycharheight; wi := 0;
  for i := 0 to nlines-1 do
    begin
      w := xycanvas.textwidth(lines[i]);
      if (w>wi) then wi := w;
    end;

  wi := wi + d+d;
  if (xjust=0) then xp := xp-wi div 2 else
   if (xjust=-1) then xp := xp - wi;
  if (yjust=0) then yp := yp-he div 2 else
   if (yjust=-1) then yp := yp - he;

  with xycanvas do
    begin

      pen.color := cl;
      if odd(mode) then pen.style := pssolid else pen.style := psclear;
      brush.color := backcolor;
      if (mode and 2 =0) then brush.style := bsclear else brush.style := bssolid;
      rectangle(xp,yp,xp+wi,yp+he+1);
      if dowmf then
        begin checkwmfpen; checkwmfbrush; blokwmf(xp,yp,xp+wi,yp+he+1); end;

      font.color := cl; brush.style := bsclear;
      for i := 0 to nlines-1 do
        begin
          w := wi-d-d-textwidth(lines[i]);
          if (xjust=0) then w := w div 2 else
          if (xjust=1) then w := 0;
          textout(xp+d+w,yp+i*xycharheight,lines[i]);
       end;

      if dowmf then
        begin
          checkwmffont;
          case xjust of
            -1 : begin textwmfalign(2); xpw := xp+wi-d; end;
             0 : begin textwmfalign(6); xpw := xp+wi div 2; end;
             1 : begin textwmfalign(0); xpw := xp+d; end;
            end;
          for i := 0 to nlines-1 do
            textwmfout(xpw,yp+i*xycharheight,lines[i]);
        end;

      pen.style := pssolid;
    end;

end;

{------------------------------------------------------------------------------}

procedure verdeling(mi,ma,incr:float;len,n:integer; var grof,fijn : float; var nach:integer);
 {berekent een schaalverdeling in max n stappen}
var fac,scale,scale0,f,p : float;
    ok : boolean;
    tel : integer;
function pos(x:float):integer;
begin pos := round((x-mi)/(ma-mi)*len); end;
begin
   if (n<1) then n := 1;
   if (mi>ma) then begin f := ma; ma := mi; mi := f; end;
   ok := false; f := 1;

   scale := ma-mi; scale0 := scale;

   repeat

   scale := scale0/(n+1e-6)*f;
   fac := 1; nach:=0;
   while (scale>=5) do begin scale := scale/10; fac := fac*10; dec(nach); end;
   while (scale<0.5) do
      begin scale := scale*10; fac := fac/10; inc(nach); end;

   if scale<1 then begin grof := fac; fijn := fac/5; end
   else
   if scale<2 then begin grof := 2*fac; fijn := fac/2; end
   else
   begin grof := 5*fac; fijn := fac; end;

   p := grof*trunc(mi/grof-1); tel := 0;
   while (pos(p)<=len) do
    begin if (pos(p)>=0) then inc(tel); p := p+grof; end;
   if (tel<2) then f := f * 0.8 else ok := true;

   if (grof<incr) then grof := incr;
   if (fijn<incr) then fijn := incr;

   until ok;
end;

procedure logverdeling(scale:float;len:integer; var fijn : float); {XXXXXXXXXXX}
 {berekent een log.schaalverdeling}
var f : float;
begin
   f := len/log10(scale)/fsize;
   if (f>250) then fijn := 224 else
   if (f>160) then fijn := 123 else
   if (f>100) then fijn := 112 else
   if (f>040) then fijn := 012 else
   if (f>007) then fijn := 001 else
   fijn := 000;
end;

{------------------------------------------------------------------------------}

procedure selectfont(siz:float); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {selecteerd font met relatieve grootte siz}
begin
  siz := siz*8;
  with xycanvas.font do
  if (siz<7.5) then
    begin name := 'Small Fonts'; size := round(siz); end
  else if screen.fonts.indexof('Arial')>=0 then
    begin name := 'Arial'; size := round(siz); end
  else
    begin
      name := 'MS Sans Serif';
      if (siz<9)  then size := 8  else
      if (siz<11) then size := 10 else
      if (siz<13) then size := 12 else
      if (siz<16) then size := 14 else
      if (siz<21) then size := 18 else
                       size := 24;
    end;
  xycharwidth := xycanvas.textwidth('0');
  xycharheight := xycanvas.textheight('0');
end;

procedure xytitle(cl:Tcolor;txt:string); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
  {tekent titel}
var l,xp : integer;
begin
  if not grafok then exit;
  selectfont(fsize*1.2);
  xycanvas.font.color := cl;
  xycanvas.font.style := [fsbold];
  xycanvas.brush.Style := bsclear;
  l := xycanvas.textwidth(txt);
  with graphs[igraph].as_[0] do xp := org + len div 2;
  with graphs[igraph] do xycanvas.textout(xp- l div 2, y1+4,txt);
  if dowmf then
    begin checkwmffont; textwmfalign(6);
    with graphs[igraph] do textwmfout(xp,y1+4,txt) end;

  selectfont(fsize);
  xycanvas.font.style := [];
end;

procedure xyunzoomx(n:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var i : integer;
begin
  if (n=0) then for i := 1 to maxgraf do with graphs[i] do
    begin xf0 := 0; xf1 := 1; end
  else if n in [1..maxgraf] then with graphs[n] do
    begin xf0 := 0; xf1 := 1; end
end;
procedure xyunzoomy(n:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var i : integer;
begin
  if (n=0) then for i := 1 to maxgraf do with graphs[i] do
    begin yf0 := 0; yf1 := 1; end
  else if n in [1..maxgraf] then with graphs[n] do
    begin yf0 := 0; yf1 := 1; end
end;
procedure xyunzoom(n:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin xyunzoomx(n); xyunzoomy(n); if (n=0) or (n=izoom) then izoom := 0; end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

procedure xyfinish;
begin
  if lastpoint then drawlastpoint;
  drawallsymbols;
end;

procedure xycleargraph(paintbox:Tpaintbox; bcolor,fcolor:Tcolor; scale:float);
 {initiatie van grafiek velden}
var i ,j : integer;
begin
  if crosson then xypaintbox.invalidate;
  screen.cursor := crdefault; crossx := 0; crossy := 0;
  crosson := false; crossok := false; blokon := false;
  xypaintbox := paintbox; xycanvas := xypaintbox.canvas;
  width := xypaintbox.width; height := xypaintbox.height;
  backcolor := bcolor; with xycanvas.brush do
     begin color := backcolor; style := bssolid; end;
  frontcolor := fcolor; with xycanvas.pen do
     begin color := frontcolor; style := pssolid; width := 1; mode := pmcopy; end;
  xycanvas.rectangle(0,0,width,height);
  if (scale=0) then scale := 1; fsize := scale; selectfont(fsize);
  tsize := xycharwidth + 1; hsize := tsize div 2 + 1;
  for i := 1 to maxgraf do with graphs[i] do
    begin xgridc := 4; xgridf := 7; ygridc := 4; ygridf := 7; ok := false; end;
  for i := 1 to maxgraf do with xygraphdata[i] do
    begin
      ok := false; x1 := 0; x2 := 0; y1 := 0; y2 := 0;
      with xaxis do
        begin on := false; min := 0; max := 0; log := false; end;
      for j := 1 to 4 do with yaxis[j] do
        begin on := false; min := 0; max := 0; log := false; end;
    end;
  ngraph := 0; igraph := 0; grafoky := false; zgraph := 0; nsymbols := 0;
  lastpoint := false;

  if dowmf then initwmf;
end;

procedure xystartgraph(x1,x2,y1,y2,dx1,dx2,dy1,dy2:integer; nclip:boolean); {XXXX}
 {set tekenveld van grafiek}
var i : integer;
begin
  if (ngraph=maxgraf) then begin grafok := false; exit; end;
  xyfinish; inc(ngraph); igraph := ngraph;
  if (x1>x2) then begin i := x1; x1 := x2; x2 := i; end;
  if (x1<0) then x1 := 0; if (x2>100) then x2 := 100;
  x1 := round(x1/100*width); graphs[igraph].x1 := x1;
  x2 := round(x2/100*width); graphs[igraph].x2 := x2;
  if (y1>y2) then begin i := y1; y1 := y2; y2 := i; end;
  if (y1<0) then y1 := 0; if (y2>100) then y2 := 100;
  y1 := round(y1/100*height); graphs[igraph].y1 := y1;
  y2 := round(y2/100*height); graphs[igraph].y2 := y2;
  x1 := x1+dx1; x2 := x2 - dx2; y1 := y1+dy1; y2 := y2-dy2;
  xorg := x1; xlen := (x2-x1); yorg := y2; ylen := y2-y1;
  grafok := (xlen>0) and (ylen>0); graphs[igraph].ok := grafok;
  crosscolor := frontcolor; zmaxy := 0;
  noclip := nclip and (graphs[igraph].xf0=0) and (graphs[igraph].xf1=1)
                  and (graphs[igraph].yf0=0) and (graphs[igraph].yf1=1);
  graphs[igraph].nclip := noclip; grafoky := false;
  for i := 0 to 4 do graphs[igraph].as_[i].on := false; crossas := 0;
  xycanvas.pen.width := 1; xycanvas.pen.style := pssolid;
  xycanvas.brush.color := backcolor; xycanvas.brush.style := bssolid;
  xygraphdata[igraph].ok := grafok;
  xygraphdata[igraph].x1 :=x1; xygraphdata[igraph].x2 :=x2;
  xygraphdata[igraph].y1 :=y1; xygraphdata[igraph].y2 :=y2;
end;

procedure xysetgridlines(xcoarse,xfine,ycoarse,yfine:integer); {XXXXXXXXXXXXXXXXX}
 {set de parameter voor de raster lijnen}
var i : integer;
begin
  if (igraph=0) then for i := 1 to maxgraf do with graphs[i] do
    begin xgridc := xcoarse; xgridf := xfine;
          ygridc := ycoarse; ygridf := yfine; end
  else with graphs[igraph] do
    begin xgridc := xcoarse; xgridf := xfine;
          ygridc := ycoarse; ygridf := yfine; end
end;

procedure xyxaxis(cl:Tcolor;x1,x2,incr,zmx:float;txt:string;grid,log,fix:boolean);
  {tekent x-as}
var grof,fijn,p,pp,tp : float;
    i,l,xp,n1,n2,n3,px,yp : integer;
    s : string;
begin
   xyfinish;
   grafokx := grafok and (x1<x2);
   if not grafokx then exit;
   if (x1<=0) then log := false;
   xycanvas.pen.color := cl; xycanvas.font.color := cl;
   xycanvas.brush.Style := bsclear;
   if dowmf then
     begin checkwmfpen; checkwmffont; {checkwmfbrush;}
        textwmfalign(6); initgrid; end;
   xlog := log; xincr := incr; xfix := fix; useroff := false;
   xyzoomx := graphs[igraph].xf1-graphs[igraph].xf0;

   xycanvas.moveto(xorg,yorg); xycanvas.lineto(xorg+xlen+1,yorg);
   if dowmf then linewmf(xorg,yorg,xorg+xlen+1,yorg);

   if not xlog then
     begin
       xmi := x1 + graphs[igraph].xf0*(x2-x1);
       xma := x1 + graphs[igraph].xf1*(x2-x1);
     end
   else
     begin
       xmi := x1*power(x2/x1,graphs[igraph].xf0);
       xma := x1*power(x2/x1,graphs[igraph].xf1);
       if (xma/xmi<lmax) then xlog := false;
     end;

   if xlog then
     begin
       zmaxx := zmax; nincx := 0;
       xypixx := power(xma/xmi,1/xlen); dxlog := ln(xma/xmi);
       logverdeling(xma/xmi,xlen,fijn);
       n1 := round(fijn) div 100;
       n2 := round(fijn) div 10 mod 10;
       n3 := round(fijn) mod 10;

       p := int(log10(xmi))-1;
       while (posx(power(10,p))<=xorg+xlen) do
         begin
           tp := power(10,p);
           for i := 10 to 99 do
             begin
               pp := tp*i/10; px := posx(pp);
               if (px>=xorg) and (px<=xorg+xlen) then
                 begin
                   xycanvas.moveto(px,yorg);
                   if i in logtics[n2] then
                     begin
                      xycanvas.lineto(px,yorg+tsize);
                      if dowmf then linewmf(px,yorg,px,yorg+tsize);
                      if grid then xgrid(px,false);
                     end
                   else
                   if i in logtics[n3] then
                     begin
                       xycanvas.lineto(px,yorg+hsize);
                       if dowmf then linewmf(px,yorg,px,yorg+hsize);
                       if grid then xgrid(px,true);
                     end;
                   if (i in logtics[n1]) and not (i in [70,90]) then
                     begin
                      s := logtxt(round(p),round(i/10));
                      l := xycanvas.textwidth(s);
                      xycanvas.textout(px-l div 2,yorg+tsize,s);
                      if dowmf then textwmfout(px,yorg+tsize,s);
                     end;
                 end;
             end;
           p := p+1;
         end;
       ndecx := ndecim(xypixx-1)+1;
     end

   else{lin}

     begin
       zmaxx := zmx/(x2-x1); if (zmaxx<zmax) then zmaxx := zmax;
       nincx := ndecim(incr); dxlog := 1;
       xypixx := (xma-xmi)/xlen;
       verdeling(xmi,xma,incr,xlen,xlen div (5*xycharwidth),grof,fijn,ndecx);
       if (ndecx>nincx) then ndecx := nincx;

       p := grof*trunc(xmi/grof-1);
       while (posx(p)<=xorg+xlen) do
         begin
           xp := posx(p);
           if (xp>=xorg) then
             begin
               xycanvas.moveto(xp,yorg);
               xycanvas.lineto(xp,yorg+tsize);
               if dowmf then linewmf(xp,yorg,xp,yorg+tsize);
               if fix then str(p:1:plus(ndecx),s) else s := lintext(p,ndecx);
               l := xycanvas.textwidth(s);
               xycanvas.textout(xp-l div 2,yorg+tsize,s);
               if dowmf then textwmfout(xp,yorg+tsize,s);
               if grid then xgrid(xp,false);
             end;
           p := p+grof;
         end;
       p := fijn*trunc(xmi/fijn);
       while (p<=xma) do
         begin
          if (p>=xmi) then
          if int(p/grof)<>(p/grof) then
            begin
               xp := posx(p);
               xycanvas.moveto(xp,yorg);
               xycanvas.lineto(xp,yorg+hsize);
               if dowmf then linewmf(xp,yorg,xp,yorg+hsize);
               if grid then xgrid(xp,true);
            end;
          p := p+fijn;
         end;
       ndecx := ndecim(xypixx);
     end;

   if (txt<>'') then
     begin
       l := xycanvas.textwidth(txt);
       xp := xorg+xlen div 2; yp := yorg+tsize+xycharheight;
       xycanvas.textout(xp - l div 2,yp,txt);
       if dowmf then textwmfout(xp,yp,txt);
     end;
   if dowmf then dogrid(yorg,yorg-ylen,true);

   with graphs[igraph].as_[0] do begin on := true; log := xlog; col := cl;
     mi := xmi; ma := xma; dlog := dxlog; org := xorg; len := xlen;
     ndec := ndecx; ninc := nincx; pix := xypixx; typ := 0;
     graphs[igraph].zmxx := zmaxx;
     end;
   with xygraphdata[igraph].xaxis do
     begin on := true; min := xmi; max := xma; log := xlog; end;
end;

procedure xyyearaxis(cl:Tcolor;code,jaar:integer;grid:boolean); {XXXXXXXXXXXXXX}
  {speciale x-as bij tijdseenheden; code 1= per dag; 2=per week; 3=per maand}
const maandnaam  = ('JFMAMJJASOND');
var i,xp,l,t,n,eerste: integer;
    c : char;
    s : string;
    st : TsystemTime;
    dt : Tdatetime;
begin
  xyfinish; useroff := false;
  grafokx := grafok and (code in [1..3]); if not grafokx then exit;
  xycanvas.pen.color := cl; xycanvas.font.color := cl;
  xycanvas.brush.Style := bsclear;
  if dowmf then
    begin checkwmfpen; textwmfalign(6); initgrid; end;
  xlog := false; xfix := true; nincx := 0; xincr := 1;
  xyzoomx := graphs[igraph].xf1-graphs[igraph].xf0;

  if (jaar=0) then
    begin datetimetosystemtime(date,st); jaar := st.wyear; end;
  dt := encodedate(jaar,1,1); eerste := dayofweek(dt); {zon=1 zat=7}

  dag[1] := 0; dag[2] := maanddagen[1];
  dag[3] := dag[2]+maanddagen[2]; if isleapyear(jaar) then inc(dag[3]);
  for i := 4 to 13 do dag[i] := dag[i-1] + maanddagen[i-1];

  case code of
  1 : begin
        xmi := graphs[igraph].xf0*(dag[13]+1);
        xma := graphs[igraph].xf1*(dag[13]+1);
        xypixx := (xma-xmi)/xlen; zmaxx := 2/365;
        xycanvas.moveto(xorg,yorg); xycanvas.lineto(xorg+xlen+1,yorg);
        if dowmf then linewmf(xorg,yorg,xorg+xlen+1,yorg);
        if (xypixx<0.3) then for i := 0 to dag[13] do
          begin xp := posx(i); if (xp>=xorg) and (xp<=xorg+xlen) then
            begin
              xycanvas.moveto(xp,yorg); xycanvas.lineto(xp,yorg+hsize);
              if dowmf then linewmf(xp,yorg,xp,yorg+hsize);
              if ( (xypixx<0.1) and odd(i) ) or (xypixx<0.05) then
                begin
                  t := 1; while (dag[t+1]<i) and (t<13) do inc(t);
                  n := i - dag[t]; str(n,s); l := xycanvas.textwidth(s);
                  xycanvas.textout(xp-l div 2,yorg+hsize,s);
                  if dowmf then textwmfout(xp,yorg+hsize,s);
                end;
            end;
          end;
        for i := 1 to 13 do
          begin xp := posx(dag[i]+0.5); if (xp>=xorg) and (xp<=xorg+xlen) then
            begin
              xycanvas.moveto(xp,yorg); xycanvas.lineto(xp,yorg+tsize);
              if dowmf then linewmf(xp,yorg,xp,yorg+tsize);
              if grid then xgrid(xp,false);
            end;
          end;
        n := 2-eerste-7;
        if grid then repeat
           n := n + 7; xp := posx(n);
           if (xp>=xorg) and (xp<=xorg+xlen) then xgrid(xp,true);
        until (n>366);

        xycanvas.font.style := [fsbold]; xycanvas.pen.color := backcolor;
        xycanvas.brush.color := backcolor; xycanvas.brush.style := bssolid;
        for i := 1 to 12 do
          begin
           c := maandnaam[i]; l := xycanvas.textwidth(c);
           xp := ( posx(dag[i])+posx(dag[i+1])) div 2;
           if (xp>xorg+hsize) and (xp<xorg+xlen-hsize) then
             begin
               xycanvas.rectangle(xp-xycharwidth,yorg+hsize-2,xp+xycharwidth,yorg+hsize+xycharheight);
               xycanvas.textout(xp - l div 2,yorg+hsize+2,c);
               if dowmf then
                 begin
                   checkwmffont; checkwmfpen; checkwmfbrush;
                   blokwmf(xp-xycharwidth,yorg+hsize-2,xp+xycharwidth,yorg+hsize+xycharheight);
                   textwmfout(xp,yorg+hsize+2,c);
                 end;
             end;
          end;
         xycanvas.pen.color := cl; xycanvas.font.style := [];
         ndecx := ndecim(xypixx);
       end;
  2 : begin
        if (taal=1) then s := 'weeek nummer'
                    else s := 'number of week';
        xyxaxis(cl,0,53,1.00,2,s,grid,lin,fixed);
        with graphs[igraph].as_[0] do begin ndec := 0; ninc := 0; typ := 2; end;
        exit;
      end;
  3 : begin
        xmi := 0.5 + graphs[igraph].xf0*12;
        xma := 0.5 + graphs[igraph].xf1*12;
        xypixx := (xma-xmi)/xlen; zmaxx := 2/12;
        xycanvas.moveto(xorg,yorg); xycanvas.lineto(xorg+xlen,yorg);
        if dowmf then linewmf(xorg,yorg,xorg+xlen,yorg);
        xycanvas.font.style := [fsbold];
        for i := 1 to 12 do
          begin
            xp := posx(i); if (xp>=xorg) and (xp<=xorg+xlen) then
              begin
                xycanvas.moveto(xp,yorg); xycanvas.lineto(xp,yorg+tsize);
                if dowmf then linewmf(xp,yorg,xp,yorg+tsize);
                if grid then xgrid(xp,false);
                c := maandnaam[i]; l := xycanvas.textwidth(c);
                xycanvas.textout(xp- l div 2,yorg+hsize+2,c);
                if dowmf then begin checkwmffont; textwmfout(xp,yorg+hsize+2,c); end;
              end;
          end;
        if grid then for i := 1 to 11 do
          begin
            xp := posx(i+0.5);
            if (xp>=xorg) and (xp<=xorg+xlen) then xgrid(xp,true);
          end;
        xycanvas.font.style := [];
        ndecx := ndecim(xypixx);
      end;
  end;
  if dowmf then dogrid(yorg,yorg-ylen,true);
  grafokx := true;
   with graphs[igraph].as_[0] do begin on := true; log := xlog; col := cl;
     mi := xmi; ma := xma; dlog := dxlog; org := xorg; len := xlen;
     ndec := ndecx; ninc := nincx; pix := xypixx; typ := code;
     graphs[igraph].zmxx := zmaxx; end;
   with xygraphdata[igraph].xaxis do
     begin on := true; min := xmi; max := xma; log := xlog; end;
end;

procedure xylabelaxis(cl:Tcolor;labels:array of string;grid:boolean);
var i,n,d,n1,n2,l,xp : integer;
    x1,x2 : float;
    s : string;
begin
  xyfinish; useroff := false;
  n1 := 0; if (labels[0]='') then n1 := 1;
  n2 := length(labels)-1;
  n := n2-n1 + 1;
  grafokx := grafok and (n>0); if not grafokx then exit;

  xycanvas.pen.color := cl; xycanvas.font.color := cl;
  xycanvas.brush.Style := bsclear;
  if dowmf then
    begin checkwmfpen; textwmfalign(6); initgrid; end;
  xlog := false; xfix := true; nincx := 0; xincr := 1;
  xyzoomx := graphs[igraph].xf1-graphs[igraph].xf0;

  x1 := 0.5; x2 := n+1-x1;
  xmi := x1 + graphs[igraph].xf0*(x2-x1);
  xma := x1 + graphs[igraph].xf1*(x2-x1);
  xypixx := (xma-xmi)/xlen; zmaxx := 2/n;
  xycanvas.moveto(xorg,yorg); xycanvas.lineto(xorg+xlen+1,yorg);
  if dowmf then linewmf(xorg,yorg,xorg+xlen+1,yorg);
  d := trunc(1/xypixx)-xycharwidth;
  for i := 1 to n do
    begin
      xp := posx(i); if (xp>=xorg) and (xp<=xorg+xlen) then
        begin
          xycanvas.moveto(xp,yorg); xycanvas.lineto(xp,yorg+tsize);
          if dowmf then linewmf(xp,yorg,xp,yorg+tsize);
          if grid then xgrid(xp,false);
          s := labels[i-1+n1]; l := xycanvas.textwidth(s);
          while (l>d) and (length(s)>1) do
            begin s := copy(s,1,length(s)-1); l := xycanvas.textwidth(s); end;
          xycanvas.textout(xp- l div 2,yorg+hsize+2,s);
          if dowmf then begin checkwmffont; textwmfout(xp,yorg+hsize+2,s); end;
        end;
    end;
  if grid then for i := 1 to n-1 do
    begin
      xp := posx(i+0.5);
      if (xp>=xorg) and (xp<=xorg+xlen) then xgrid(xp,true);
    end;
  ndecx := ndecim(xypixx);
  if dowmf then dogrid(yorg,yorg-ylen,true);

  grafokx := true;
   with graphs[igraph].as_[0] do begin on := true; log := xlog; col := cl;
     mi := xmi; ma := xma; dlog := dxlog; org := xorg; len := xlen;
     ndec := ndecx; ninc := nincx; pix := xypixx; typ := 0;
     graphs[igraph].zmxx := zmaxx; end;
   with xygraphdata[igraph].xaxis do
     begin on := true; min := xmi; max := xma; log := xlog; end;
end;

procedure xyyaxis(cl:Tcolor;y1,y2,incr,zmx:float;txt:string;code:integer;grid,log,fix:boolean);
 {tekent y-as, code =positie}
var grof,fijn,p,pp,tp,z : float;
    xp,bi,ltxt,i,l,h,py,n1,n2,n3,yp,xp2 : integer;
    s : string;
begin
   xyfinish;
   grafoky := grafokx and (y1<y2) and (code in [1..4]);
   if not grafoky then exit;
   if (y1<=0) then log := false;
   xyzoomy := graphs[igraph].yf1-graphs[igraph].yf0;

   yincr := incr; nincy := ndecim(incr);
   ltxt := 0; useroff := false;

   xycanvas.pen.color := cl; xycanvas.font.color := cl;
   xycanvas.brush.Style := bsclear;
   if dowmf then
     begin checkwmfpen; checkwmffont; {checkwmfbrush;} initgrid;
     if odd(code) then textwmfalign(2) else textwmfalign(0); end;
   ylog := log;
   case code of
     1 : xp := xorg;
     2 : xp := xorg+1;
     3 : xp := xorg+xlen-1;
     4 : xp := xorg+xlen;
    end;
   if odd(code) then bi := -1 else bi := 1;
   xycanvas.moveto(xp,yorg); xycanvas.lineto(xp,yorg-ylen-1);
   if dowmf then linewmf(xp,yorg,xp,yorg-ylen-1);

   if not ylog then
     begin
       ymi := y1 + graphs[igraph].yf0*(y2-y1);
       yma := y1 + graphs[igraph].yf1*(y2-y1);
     end
   else
     begin
       ymi := y1*power(y2/y1,graphs[igraph].yf0);
       yma := y1*power(y2/y1,graphs[igraph].yf1);
       if (yma/ymi<lmax) then ylog := false;
     end;

   if ylog then
     begin
       zmaxy := zmax; nincx := 0;
       xypixy := power(yma/ymi,1/ylen); dylog := ln(yma/ymi);
       logverdeling(yma/ymi,ylen,fijn);
       n1 := round(fijn) div 100;
       n2 := round(fijn) div 10 mod 10;
       n3 := round(fijn) mod 10;

       p := int(log10(ymi))-1;
       while (posy(power(10,p))>=yorg-ylen) do
         begin
           tp := power(10,p);
           for i := 10 to 99 do
             begin
               pp := tp*i/10; py := posy(pp);
               if (py>=yorg-ylen) and (py<=yorg) then
                 begin
                   xycanvas.moveto(xp,py);
                   if i in logtics[n2] then
                     begin
                      xycanvas.lineto(xp+tsize*bi,py);
                      if dowmf then linewmf(xp,py,xp+(tsize-0)*bi,py);
                      if grid then ygrid(py,false);
                     end
                   else
                   if i in logtics[n3] then
                     begin
                      xycanvas.lineto(xp+hsize*bi,py);
                      if dowmf then linewmf(xp,py,xp+(hsize-0)*bi,py);
                      if grid then ygrid(py,true);
                     end;
                   if i in logtics[n1] then
                     begin
                       s := logtxt(round(p),round(i/10));
                       l := xycanvas.textwidth(s);
                       yp := py-xycharheight div 2;
                       if odd(code) then
                         xycanvas.textout(xp+tsize*bi-l,py-xycharheight div 2,s)
                       else xycanvas.textout(xp+tsize*bi+1,py-xycharheight div 2,s);
                       if dowmf then textwmfout(xp+tsize*bi,yp,s);
                       if (l>ltxt) then ltxt := l;
                     end;
                 end;
             end;
           p := p+1;
         end;
       ndecy := ndecim(xypixy-1)+1;
     end

   else {lin}

     begin
       if (zmaxy=0) then zmaxy := zmx/(y2-y1);
       xypixy := (yma-ymi)/ylen; nincy := ndecim(incr);
       verdeling(ymi,yma,incr,ylen,ylen div (2*xycharheight),grof,fijn,ndecy);
       if (ndecy>nincy) then ndecy := nincy;

       p := grof*trunc(ymi/grof-1);
      while (posy(p)>=yorg-ylen) do
         begin
           if (posy(p)<=yorg) then
             begin
               yp := posy(p);
               xycanvas.moveto(xp,yp);
               xycanvas.lineto(xp+tsize*bi,yp);
               if dowmf then linewmf(xp,yp,xp+(tsize-0)*bi,yp);
               if fix then str(p:1:plus(ndecy),s) else s := lintext(p,ndecy);
               l := xycanvas.textwidth(s); if (l>ltxt) then ltxt := l;
               yp := yp-xycharheight div 2;
               if odd(code) then
                     xycanvas.textout(xp+tsize*bi-l,yp,s)
                else xycanvas.textout(xp+tsize*bi+1,yp,s);
                if dowmf then textwmfout(xp+tsize*bi,yp,s);

               if grid or (p=0) then ygrid(posy(p),false);
             end;
           p := p+grof;
         end;
       p := fijn*trunc(ymi/fijn);
       while (posy(p)>=yorg-ylen) do
         begin
           if (posy(p)<=yorg) then
           if int(p/grof)<>(p/grof) then
             begin
               yp := posy(p);
               xycanvas.moveto(xp,yp);
               xycanvas.lineto(xp+hsize*bi,yp);
               if dowmf then linewmf(xp,yp,xp+(hsize-0)*bi,yp);
               if grid then ygrid(posy(p),true);
             end;
           p := p+fijn;
         end;
       ndecy := ndecim(xypixy);
     end;

   if (txt<>'') then
   begin

   h := yorg-ylen-xycharheight - xycharheight div 2;
   if (txt[1]='@') then begin h := h - xycharheight; txt := copy(txt,2,99); end;
   {str(pixy:1:3,s); txt := txt + ' ' + s;}
   l := xycanvas.TextWidth(txt);
   case code of
     1 : xycanvas.textout(max(xorg-ltxt-tsize,0),h,txt);
     2 : xycanvas.textout(xorg,h,txt);
     3 : xycanvas.textout(xorg+xlen-l,h,txt);
     4 : xycanvas.textout(min(xorg+xlen+ltxt+tsize,width)-l,h,txt);
   end;
   if dowmf then
   case code of
     1 : begin textwmfalign(0); textwmfout(max(xorg-ltxt-tsize,0),h,txt); end;
     2 : begin textwmfalign(0); textwmfout(xorg,h,txt); end;
     3 : begin textwmfalign(2); textwmfout(xorg+xlen,h,txt); end;
     4 : begin textwmfalign(2); textwmfout(min(xorg+xlen+ltxt+tsize,width),h,txt); end;
   end;

   end;

   if dowmf then dogrid(xorg,xorg+xlen,false);

   with graphs[igraph].as_[code] do begin on := true; log := ylog; col := cl;
     mi := ymi; ma := yma; dlog := dylog; org := yorg; len := ylen;
     ndec := ndecy; ninc := nincy; pix := xypixy; typ := 0;
     graphs[igraph].zmxy := zmaxy; end;
   with xygraphdata[igraph].yaxis[code] do
     begin on := true; min := ymi; max := yma; log := xlog; end;
   crossas := code;
   xycanvas.pen.mode := pmcopy;
   if (zgraph=0) then zgraph := igraph else
     if (zgraph>0) and (zgraph<>igraph) then zgraph := -1;
end;

{------------------------------------------------------------------------------}

procedure xybar(cl:Tcolor;pos,wi,hi:float;just:integer); {XXXXXXXXXXXXXXXXXXXXXXX}
 {tekent staaf als in bar chart; just: -1 = naar links, 0=midden, 1=naar rechts}
var x1,x2,y1,y2,w,t:integer;
begin
  if not grafoky then exit;
  xycanvas.brush.color := cl;
  if (hi=0) then exit;
  if useroff then x1 := round(pos) else x1 := posx(pos);
  if useroff or xlog then w := round(wi) else w := round(wi/xypixx);
  if (just=-1) then x1 := x1-w + 1 else
    if (just=0) then x1 := x1 - w div 2;
  if useroff then
    begin y1 := bar0; y2 := bar0-round(hi); end
  else
    begin y1 := posy(0); y2 := posy(hi); end;
  x2 := x1+w-1;
  if (y1>y2) then begin t := y1; y1 := y2; y2 := t; end;
  if not (noclip or useroff) then
    begin
      if (x2<xorg) or (x1>xorg+xlen) or (y1>yorg) or (y2<yorg-ylen) then exit;
      if (x1<xorg) then x1 := xorg;
      if (x2>xorg+xlen) then x2 := xorg+xlen;
      if (y1<yorg-ylen) then y1 := yorg-ylen;
      if (y2>yorg) then y2 := yorg;
    end;
  with xycanvas do
    begin
      pen.style := psclear;
      rectangle(x1-1,y1,x2+1,y2+1);
      if dowmf then
        begin checkwmfpen; checkwmfbrush; blokwmf(x1-1,y1,x2+1,y2+1); end;
      pen.style := pssolid;
    end;

end;

{------------------------------------------------------------------------------}

procedure xylegendclear; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin xylegendcount := 0; setlength(legends,0); end;

procedure xylegendentry(cd:integer; text:string); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var i : integer;
    col : Tcolor;
begin
  if not (cd in [0..3]) then exit;
  with xycanvas do  case cd of
    0 : col := pen.color;
    1 : col := brush.color;
   2,3 : col := lastsymbol.color;
    end;
  if (colortorgb(col)=colortorgb(backcolor)) then exit;

  xylegendcount := length(legends);
  for i := 0 to xylegendcount-1 do with legends[i] do
    if ( (txt=text) and (code=cd) ) then exit;

  inc(xylegendcount); setlength(legends,xylegendcount);
  with legends[xylegendcount-1] do with xycanvas do
    begin
      txt := text;
      code := cd;
      case code of
        0 : begin cl := col; lwidth := pen.width; lstyle := integer(pen.style); end;
        1 : begin cl := col; lstyle := integer(brush.style); end;
       2,3 : with lastsymbol do
        begin cl := col; lwidth := width; lstyle := style; lfill := fill; end;
      end;
    end;
end;

procedure xylegendmake(style,xp,yp,xjust,yjust,wi,he,len:integer; framed:boolean);
 {style 0 = hor, 1 regel; 1 = hor, 2 regels; 2 = vert, 2 kol; 3 = vert, 1 kol}
const br = 20;
      d1 = 4;
      d2 = 6;
      d3 = 1;
var i,mwi,mhe,w,x,y,fl,ll,tw,fh,h,h2,xof : integer;
    d : float;

procedure drawleg(xp,yp,n:integer); { X X X X X X X X X X X X X X X X X X X X X}
var sym : symboltype;
begin
  with legends[n] do with xycanvas do
  case code of
    0 : begin pen.color := cl; pen.width := lwidth; pen.style := TPenStyle(lstyle);
         yp := yp + h2; moveto(xp,yp); lineto(xp+ll,yp);
         if dowmf then begin checkwmfpen; linewmf(xp,yp,xp+ll,yp); end;
        end;
    1 : begin
          xp := xp + ll div 2;
          brush.color := cl; brush.style := TBrushStyle(lstyle);
          pen.style := psclear; rectangle(xp-br div 2,yp+1,xp+br div 2+1,yp+h);
         if dowmf then
           begin checkwmfpen; checkwmfbrush;
            blokwmf(xp-br div 2,yp+1,xp+br div 2+1,yp+h); end;
        end;
   2,3 : begin
          xp := xp + ll div 2; yp := yp + h2;
          sym.xp := xp; sym.yp := yp;
          sym.style := lstyle; sym.size := xycanvas.font.size;
          sym.fill := lfill; sym.width := lwidth; sym.color := cl;
          drawsymbol(sym);
          pen.width := 1; pen.color := cl;
          if (lfill=0) and (code=3) and (lstyle in [1..6]) then
            begin
             ellipse(xp-1,yp-1,xp+2,yp+2);
             if dowmf then
               begin
                 checkwmfpen;
                 ellipsewmf(xp-1,yp-1,xp+2,yp+2);
               end;
            end;
        end;
    end;
end;
procedure drawtext(xp,yp,n:integer;center:boolean); { X X X X X X X X X X X X X}
var w : integer;
    s : string;
begin
  s := legends[n].txt;
  with xycanvas do
    begin
      if center then w := textwidth(s) div 2 else w := 0;
      font.color := legends[n].cl; brush.style := bsclear;
      textout(xp-w,yp,s);
    end;  
  if dowmf then
    begin checkwmffont; textwmfout(xp,yp,s); end;
end;

procedure drawhor(xp,yp,n:integer);  { X X X X X X X X X X X X X X X X X X X X}
begin drawleg(xp,yp,n); drawtext(xp+ll+d1,yp,n,false); end;
procedure drawver(xp,yp,n:integer);  { X X X X X X X X X X X X X X X X X X X X}
begin drawleg(xp-ll div 2,yp,n); drawtext(xp,yp+h,n,true); end;
procedure xydraw(xp,yp,n:integer); { X X X X X X X X X X X X X X X X X X X X X X}
begin if odd(style) then drawver(xp,yp,n) else drawhor(xp,yp,n); end;

begin
  xylegendcount := length(legends);
  if (xylegendcount=0) then exit;
  if not (style in [0..3]) then exit;
  h := xycanvas.textheight('0'); h2 := h div 2; store;

  tw := 0;
  for i := 0 to xylegendcount-1 do
    begin
      w := xycanvas.textwidth(legends[i].txt);
      if (w>tw) then tw := w;
    end;

  if (len<br) then ll := br else ll := len;
  if odd(style) then {teken en tekst onder elkaar}
    begin fl := max(ll,tw); ll := fl; fh := 2 * h; xof := fl div 2; end
  else {teken en tekst naast elkaar}
    begin fl := ll + d1 + tw; fh := h; xof := 0; end;

  if dowmf then if odd(style) then textwmfalign(6) {center alle tekst}
     else textwmfalign(0);

  case style of
   0,1 : begin mwi := d2+xylegendcount*(fl+d2); mhe := d3+fh+d3; end;
   2,3 : begin mwi := d2+fl+d2; mhe := d3+xylegendcount*fh+d3; end;
  end;
  if (wi<mwi) then wi := mwi;
  if (he<mhe) then he := mhe;

  if (xjust=0) then xp := xp-wi div 2 else
   if (xjust=-1) then xp := xp - wi;
  if (yjust=0) then yp := yp-he div 2 else
   if (yjust=-1) then yp := yp - he;

  if framed then with xycanvas do
    begin
      pen.color := frontcolor; pen.style := pssolid;
      brush.color := backcolor; brush.style := bssolid;
      rectangle(xp,yp,xp+wi,yp+he+1);
      if dowmf then
        begin checkwmfpen; checkwmfbrush;
          blokwmf(xp,yp,xp+wi,yp+he+1); end;
    end;

  case style of
   0,1 : begin
         y := (he-fh) div 2;
         d := (wi - fl*xylegendcount) / (xylegendcount+1);
         for i := 0 to xylegendcount-1 do
           begin
             x := round(i*(d+fl)+d) + xof;
             xydraw(xp+x,yp+y,i);
           end;
       end;
   2,3 : begin
         x := (wi-fl) div 2 + xof;
         d := (he-d3-d3 - fh*xylegendcount) / (xylegendcount+1);
         for i := 0 to xylegendcount-1 do
           begin
             y := d3+round( d + i*(fh+d));
             xydraw(xp+x,yp+y,i);
           end;
       end;
   end;
   xycanvas.pen.width := 1;
   restore;
   xylegendclear;
end;

{------------------------------------------------------------------------------}

procedure xyinitruler(cl:Tcolor;xp,yp,j:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {initieert lineaal}
begin
  crossxp := xp; crossyp := yp; crossj := j; crossok := true;
  crossx := 0; crossy := 0;
  crosscolor := cl;
end;

procedure xysetusercoordinates(n,ny:integer);
begin
  if (n<0) or (n>maxgraf) then exit;
  xyfinish;
  if (n=0) then
    begin
      useroff := true; bar0 := ny;
      xycanvas.pen.color := frontcolor; exit;
    end;
  useroff := false;
  if not graphs[n].ok then exit;
  with graphs[n] do
    begin
      if not (as_[ny].on and as_[0].on) then exit;
      with as_[0] do
        begin
          xlog := log; xmi := mi; xma := ma;
          xorg := org; xlen := len; dxlog := dlog;
        end;
      with as_[ny] do
        begin
          ylog := log; ymi := mi; yma := ma;
          yorg := org; ylen := len; dylog := dlog;
          xycanvas.pen.color := col;
        end;
    end;
end;

procedure cross(x,y:integer;show:boolean); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {tekent lineaal}
var s,ss : string;
    l,n : integer;
begin
   with graphs[igraph] do begin

   with as_[0] do if (x<org) then x := org else if (x>org+len) then x := org+len;
   with as_[crossas] do if (y>org) then y := org else if (y<org-len) then y := org-len;
   xycanvas.pen.mode := pmxor;
   xycanvas.pen.color := crosscolor xor backcolor;
   xycanvas.pen.width := 1;
   xycanvas.moveto(x,as_[crossas].org);
   xycanvas.lineto(x,as_[crossas].org-as_[crossas].len);
   xycanvas.moveto(as_[0].org,y);
   xycanvas.lineto(as_[0].org+as_[0].len,y);
   xycanvas.pen.mode := pmcopy;

   end;

   if crossok then with graphs[igraph] do
     begin
       {xycanvas.brush.style := bsclear;}
       with as_[0] do if log then s := signif(xwaarde(x),ndec) else
         if (typ=1) then s := datum(round(xwaarde(x))) else
         begin n := min(ndec,ninc); s := showdec(xwaarde(x),n); end;
       with as_[crossas] do if log then ss := signif(ywaarde(y,crossas),ndec) else
         begin n := min(ndec,ninc); ss := showdec(ywaarde(y,crossas),n); end;
       case crossj of
         -1 : l := xycanvas.textwidth(s+' / '+ss);
         0 : l := xycanvas.textwidth(s+' / '+ss) div 2;
         1 : l := 0;
       end;
       if not show then
         begin
           xycanvas.font.color := backcolor;
           xycanvas.textout(crossxp-l,crossyp,s+' / '+ss);
         end
       else
         begin
           xycanvas.font.color := as_[0].col;
           xycanvas.textout(crossxp-l,crossyp,s+' / ');
           xycanvas.font.color := as_[crossas].col;
           xycanvas.textout(xycanvas.penpos.x,crossyp,ss);
         end;
     end;
   crossx := x; crossy := y;
end;

procedure blok(x,y:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {tekent blok ivm zoom}
begin
   xycanvas.pen.mode := pmxor;
   xycanvas.pen.color := clwhite;
   xycanvas.pen.width := 1;
   {xycanvas.pen.style := psdot;}
   xycanvas.moveto(blokx0,bloky0); xycanvas.lineto(x,bloky0);
   xycanvas.lineto(x,y); xycanvas.lineto(blokx0,y);
   xycanvas.lineto(blokx0,bloky0);
   xycanvas.pen.mode := pmcopy;
   xycanvas.pen.style := pssolid;
   blokx1 := x; bloky1 := y;
end;

procedure zoom; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 {rekent nieuwe zoom parameters uit en tekent grafiek opnieuw}
var xff0,xff1,yff0,yff1 : float;
    t : integer;
begin
  with graphs[igraph] do begin

  if (zmxy<zmax) then zmxy := zmax;
  if (abs(blokx0-blokx1)<=1) and (abs(bloky0-bloky1)<=1) then
    begin xyunzoom(igraph); xypaintbox.refresh; exit; end;
  if (blokx0>blokx1) then begin t := blokx0; blokx0 := blokx1; blokx1 := t; end;
  if (bloky0<bloky1) then begin t := bloky0; bloky0 := bloky1; bloky1 := t; end;
  with as_[0] do
    begin xff0 := (blokx0-org)/len; xff1 := (blokx1-org)/len; end;
  with as_[crossas] do
    begin yff0 := (org-bloky0)/len; yff1 := (org-bloky1)/len; end;
  xff0 := xf0 + xff0*(xf1-xf0);
  xff1 := xf0 + xff1*(xf1-xf0);
  yff0 := yf0 + yff0*(yf1-yf0);
  yff1 := yf0 + yff1*(yf1-yf0);
  xf0 := xff0; xf1 := xff1; yf0 := yff0; yf1 := yff1;
  if (xf0<0) then xf0 := 0;
  if (xf1>1) then xf1 := 1;
  if (yf0<0) then yf0 := 0;
  if (yf1>1) then yf1 := 1;
  if (xf1-xf0)<zmxx then
     begin xf0 := (xf1+xf0)/2-zmxx/2; xf1 := xf0+zmxx; end;
  if (yf1-yf0)<zmxy then
     begin yf0 := (yf1+yf0)/2-zmxy/2; yf1 := yf0+zmxy; end;

  end;
  izoom := igraph;
  xypaintbox.refresh;
end;

procedure xysetzoom(n:integer; fx0,fx1,fy0,fy1:float); {XXXXXXXXXXXXXXXXXXXXXXXXX}
 {stelt zoom parameters handmatig in en tekent grafiek opnieuw}
begin
  if (n<1) or (n>maxgraf) then exit;
  if not graphs[n].ok then exit;
  with graphs[n] do begin

  if (fx0>=0) and (fx0<=1) then xf0 := fx0;
  if (fx1>=0) and (fx1<=1) then xf1 := fx1;
  if (fy0>=0) and (fy0<=1) then yf0 := fy0;
  if (fy1>=0) and (fy1<=1) then yf1 := fy1;
  if (xf1-xf0)<zmaxx then
     begin xf0 := (xf1+xf0)/2-zmxx/2; xf1 := xf0+zmxx; end;
  if (yf1-yf0)<zmaxy then
     begin yf0 := (yf1+yf0)/2-zmxy/2; yf1 := yf0+zmxy; end;

  end;
  xypaintbox.refresh;
  izoom := n;
end;

{------------------------------------------------------------------------------}

procedure xycopytoclipboard; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{kopieert grafiek naar klembord}
var bitmap : Tbitmap;
    copyrect : Trect;
begin
   with xypaintbox do
     begin
       bitmap := Tbitmap.create;
       bitmap.width := width;
       bitmap.height := height;
       copyrect := rect(0,0,width,height);
       bitmap.canvas.copyrect(copyrect,canvas,copyrect);
       clipboard.assign(bitmap);
       bitmap.free;
     end;
end;

procedure xysaveasmetafile(s:string; showtxt:boolean; var ok:boolean); {XXXXXXXXX}
 {maakt metafile aan}
begin
  openwmf(s,ok);
  if not ok then
   begin
     beep;
     if (taal=1) then s := 'Fout bij openen metafile '+s
                 else s := 'Error opening metafile '+s;
     if showtxt then application.messagebox(@s[1],'File Error',mb_OK+mb_Iconerror);
     exit;
   end;
  xypaintbox.repaint;
  closewmf(ok);
  if not ok then
    begin
      beep;
      if (taal=1) then s := 'Fout bij schrijven metafile '+s
                  else s := 'Error writing metafile '+s;
      if showtxt then application.messagebox(@s[1],'File Error',mb_OK+mb_Iconerror);
      exit;
    end;
  if (taal=1) then s := 'OK: metafile '+s+' aangemaakt.'
              else s := 'OK: metafile '+s+' created.';
  if showtxt then showmessage(s);
end;

{MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM}

procedure XYMouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var i,xx : integer;
begin
  {xypaintbox.invalidate;}
  if not crosson or blokon then {zoek welke grafiek en yas}
    begin
      igraph := 0;
      for i := 1 to ngraph do with graphs[i] do if ok then
        if (x>=x1) and (x<=x2) and (y>=y1) and (y<=y2) then igraph := i;
      if (igraph=0) then exit;
      crossas := 0;
      with graphs[igraph] do begin
        for i := 4 downto 1 do if graphs[igraph].as_[i].on
           then crossas := i;
        if (crossas=0) or not as_[0].on then exit;
      end;
    end;

  with graphs[igraph] do
  if (button=mbleft) then
    if (ssCtrl in shift) then
      begin blokon := true; blokx0 := x; bloky0 := y; blok(x,y); end
    else if (x>as_[0].org) and (X<as_[0].org+as_[0].len)
      and (y<as_[crossas].org) and (y>as_[crossas].org-as_[crossas].len) then
      begin crosson := true; cross(x,y,true); screen.cursor := crnone; end;

  if (button=mbright) and crosson then
    begin
      cross(crossx,crossy,false);
      repeat
       inc(crossas);
       if (crossas=5) then crossas := 1;
       until graphs[igraph].as_[crossas].on;
      cross(crossx,crossy,true);
    end;
end;

procedure XYMouseMove(Shift: TShiftState;  X, Y: Integer); {XXXXXXXXXXXXXXXXXXX}
begin
  if (ssleft in shift) then
    begin
      if crosson then begin cross(crossx,crossy,false); cross(x,y,true); end;
      if blokon then begin blok(blokx1,bloky1); blok(x,y); end;
    end;
end;

procedure XYMouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (button=mbleft) then
    begin
      if crosson then  begin
        cross(crossx,crossy,false); crosson := false; crossx := 0; crossy := 0;
        screen.cursor := crdefault;
       end;
      if blokon then  begin
        blok(blokx1,bloky1); blokon := false;
        if (ssCtrl in shift) then zoom;
       end;
    end;
end;

procedure XYKeyDown(Key: Word; Shift: TShiftState); {XXXXXXXXXXXXXXXXXXXXXXXXXX}
var dxf,dyf : float;
begin
  if (izoom=0) and (zgraph>0) then izoom := zgraph;
  if (izoom<=0) or not graphs[izoom].ok then exit;

  with graphs[izoom] do begin

  if (zmxy<zmax) then zmxy := zmax;

  dxf := xf1-xf0; dyf := yf1-yf0;
  if ssctrl in shift then
    case key of
      VK_ADD :
        begin
          xf0 := xf0 + dxf / 4; xf1 := xf1 - dxf / 4;
          yf0 := yf0 + dyf / 4; yf1 := yf1 - dyf / 4;
          if (xf1-xf0)<zmxx then
            begin xf0 := (xf1+xf0)/2-zmxx/2; xf1 := xf0+zmxx; end;
          if (yf1-yf0)<zmxy then
            begin yf0 := (yf1+yf0)/2-zmxy/2; yf1 := yf0+zmxy; end;
          xypaintbox.repaint;
        end;
     VK_SUBTRACT :
        begin
          xf0 := xf0 - dxf / 2; xf1 := xf1 + dxf / 2;
          yf0 := yf0 - dyf / 2; yf1 := yf1 + dyf / 2;
          if (xf0<0) then xf0 := 0; if (xf1>1) then xf1 := 1;
          if (yf0<0) then yf0 := 0; if (yf1>1) then yf1 := 1;
          xypaintbox.repaint;
        end;
     VK_RIGHT, VK_NUMPAD6 :
        begin
          xf1 := xf1 + dxf / 4; if (xf1>1) then xf1 := 1;
          xf0 := xf1 - dxf;
          xypaintbox.repaint;
        end;
     VK_LEFT, VK_NUMPAD4 :
        begin
          xf0 := xf0 - dxf / 4; if (xf0<0) then xf0 := 0;
          xf1 := xf0 + dxf;
          xypaintbox.repaint;
        end;
     VK_UP, VK_NUMPAD8 :
        begin
          yf1 := yf1 + dyf / 4; if (yf1>1) then yf1 := 1;
          yf0 := yf1 - dyf;
          xypaintbox.repaint;
        end;
     VK_DOWN, VK_NUMPAD2 :
        begin
          yf0 := yf0 - dyf / 4; if (yf0<0) then yf0 := 0;
          yf1 := yf0 + dyf;
          xypaintbox.repaint;
        end;
     VK_RETURN :
        begin
          xyunzoom(izoom);
          xypaintbox.repaint;
        end;
    end;
  end;
end;

begin
  xyunzoom(0); taal := 0;
  oldpen := Tpen.create;
  oldbrush := Tbrush.create;
end.

